#line 1 "code.bas"
 // Example SeaBass Program
#line 2 "code.bas"
 // Sends a little Morse code on an LED on Port B pin 0
#line 4 "code.bas"
#include <avr/io.h>
#line 5 "code.bas"
 // get I/O routines
#line 1 "avrio.bh"
#line 2 "avrio.bh"
/* This header defines a few macros that are useful for porting code
#line 3 "avrio.bh"
   from other languages (although they are not necessarily very efficient)
#line 5 "avrio.bh"
   HIGH - Set pin to output and set high (example: HIGH(C,2);)
#line 6 "avrio.bh"
   LOW - Set pin to output and set low (example: LOW(B,0); )
#line 7 "avrio.bh"
   TOGGLE - Set pin to output and reverse state
#line 8 "avrio.bh"
   OUTPUT - Make pin output
#line 9 "avrio.bh"
   INPUT - Make pin input
#line 10 "avrio.bh"
   REVERSE - Make input pin an output or output pin an input
#line 11 "avrio.bh"
   IREAD - Make pin input and return 1 or 0 based on pin state
#line 13 "avrio.bh"
This is part of the APP4 distribution from AWC
#line 14 "avrio.bh"
http://www.awce.com/app4.htm
#line 15 "avrio.bh"
*/
#line 17 "avrio.bh"
#ifndef _AWC_APP4IO_H
#line 18 "avrio.bh"
#define _AWC_APP4IO_H
#line 20 "avrio.bh"
#define MKTOKEN(a,b) a ## b
#line 21 "avrio.bh"
#define HIGH(port,pin) ( MKTOKEN(PORT,port) |= (1<<(pin)), MKTOKEN(DDR,port) |= (1<<(pin)))
#line 22 "avrio.bh"
#define LOW(port,pin) ( MKTOKEN(PORT,port) &= ~(1<<(pin)), MKTOKEN(DDR,port) |= (1<<(pin)))
#line 23 "avrio.bh"
#define TOGGLE(port,pin) ( MKTOKEN(PORT,port) ^= (1<<(pin)), MKTOKEN(DDR,port)|= (1<<(pin)))
#line 24 "avrio.bh"
#define OUTPUT(port,pin) ( MKTOKEN(DDR,port) |= (1<<(pin)))
#line 25 "avrio.bh"
#define INPUT(port,pin) (MKTOKEN(DDR,port) &= ~(1<<(pin)))
#line 26 "avrio.bh"
#define REVERSE(port,pin) (MKTOKEN(DDR,port) ^= (1<<(pin)))
#line 27 "avrio.bh"
#define IREAD(port,pin) (MKTOKEN(DDR, port) &= ~(1<<(pin)),((MKTOKEN(PIN,port)) &= (1<<(pin)))!=0)
#line 30 "avrio.bh"
#endif
#line 31 "avrio.bh"
#line 6 "code.bas"
#include <app4delay.h> // get delay routines (from C)
#line 7 "code.bas"
#line 9 "code.bas"
 // Define a string type
#line 10 "code.bas"
typedef  char * string;
#line 13 "code.bas"
 // Speed of a dot in milliseconds
#line 14 "code.bas"
#define speed (200)
#line 17 "code.bas"
 // play a dot
#line 18 "code.bas"
void dot(void) {
#line 19 "code.bas"
	HIGH(B,0)         ; // LED on 
#line 20 "code.bas"
	delay_ms(speed);
#line 21 "code.bas"
	LOW(B,0)          ; // LED off
#line 22 "code.bas"
	delay_ms(speed);
#line 23 "code.bas"
	}
#line 25 "code.bas"
 // play a dash
#line 26 "code.bas"
void dash(void) {
#line 27 "code.bas"
	HIGH(B,0);
#line 28 "code.bas"
	delay_ms(speed*3);
#line 29 "code.bas"
	LOW(B,0);
#line 30 "code.bas"
	delay_ms(speed);
#line 31 "code.bas"
	}
#line 33 "code.bas"
 // pause between characters
#line 34 "code.bas"
void space(void) {
#line 35 "code.bas"
	delay_ms(speed*3);
#line 36 "code.bas"
	}
#line 39 "code.bas"
 // Main program
#line 40 "code.bas"
int main(void) {
#line 41 "code.bas"
	string text;
#line 42 "code.bas"
	int i;
#line 44 "code.bas"
	text="-.-. --.-"   ; // message to send
#line 46 "code.bas"
 // Set LED to output
#line 47 "code.bas"
	OUTPUT(B,0);
#line 49 "code.bas"
 // Main code
#line 50 "code.bas"
top:
#line 51 "code.bas"
	for (i=0;i<=strlen(text)-1;i++) { // walk through text
#line 52 "code.bas"
 // do the right thing
#line 53 "code.bas"
		if (text[i]=='.' ) {
#line 54 "code.bas"
			dot();
#line 55 "code.bas"
			}
#line 56 "code.bas"
		if (text[i]=='-' ) {
#line 57 "code.bas"
			dash();
#line 58 "code.bas"
			}
#line 59 "code.bas"
		if (text[i]==' ' ) {
#line 60 "code.bas"
			space();
#line 61 "code.bas"
			}
#line 62 "code.bas"
		}
#line 63 "code.bas"
	delay_ms(10000)   ; // wait 10 seconds
#line 64 "code.bas"
	goto top          ; // and do it again
#line 65 "code.bas"
	}
